/* External queue-utility sample for rtnppd v1.3 by Vasim V.
 * This program do nothing with all packets (just receive and send back).
 * See comments. */
/* $Id: testq.c,v 1.1 1998/11/21 19:35:46 vasim Exp $ */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>

main(int argc, char *argv[]) {
  char buffer[5120];
  int res;
  struct sockaddr_un sun, suno;
  int s;

  /* Check arguments */
  if (argc != 3) {
    fprintf(stderr,
	    "\nUsage:\n\ttestq <rtnppd-out.socket> <rtnppd-in.socket>\n\n");
    fprintf(stderr, "Example for default values:\n");
    fprintf(stderr, "\ttestq /var/run/rtnppd.queue.out");
    fprintf(stderr, " /var/run/rtnppd.queue.in\n\n");
    exit(1);
  }

  /* Fill up sockaddr_un structures */
  memset(&sun, 0, sizeof(sun));
  sun.sun_family = AF_UNIX;
  snprintf(sun.sun_path, sizeof(sun.sun_path), "%s", argv[1]);
  memset(&suno, 0, sizeof(suno));
  suno.sun_family = AF_UNIX;
  snprintf(suno.sun_path, sizeof(suno.sun_path), "%s", argv[2]);

  /* Create and bind socket */
  s = socket(AF_UNIX, SOCK_DGRAM, 0);
  if (s < 0) {
    fprintf(stderr, "Can't create new socket. Error '%s' (%d)\n",
	    strerror(errno), errno);
    exit(1);
  }
  unlink(sun.sun_path);
  res = bind(s, (struct sockaddr *) &sun, strlen(sun.sun_path) + 2);
  if (res < 0) {
    fprintf(stderr, "Can't connect to socket. Error '%s' (%d)\n",
	    strerror(errno), errno);
    exit(1);
  }

  /* Main loop */
  while (1) {
    /* Wait for new packet */
    res = recv(s, buffer, sizeof(buffer), 0);
    if (res < 0)
      fprintf(stderr, "Read error '%s' (%d)\n", strerror(errno), errno);
    else {
      /* New packet received. Here you can do something with packet... */

      /* Send packet back to rtnppd */
      res = sendto(s, buffer, res, 0, (struct sockaddr *) &suno,
		   strlen(suno.sun_path) + 2);
      if (res <= 0)
	fprintf(stderr, "Send error '%s' (%d)\n", strerror(errno), errno);
    }
  }
}
